﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	//import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var sketch:BitmapData;
		var screen:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var lineStack:Array;
		//var matrix:Matrix;
		
		private var color:uint;
		private var index:uint;
		
		public function IntuitiveDrawer():void
		{
			sketch = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xffffff);
			screen = new Bitmap(sketch);
			addChild(screen);

						
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
		}
			
			
		private function startDessine(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,floodit);
			//matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(1,0x000000,1);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY));
		}
		
		
		private function dessine(e:MouseEvent):void
		{
			if(line != null)
			{
				line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(e.stageX,e.stageY));
				addChild(line);
			}
		}
		
		
		private function stopDessine(e:MouseEvent):void
		{
			if(line != null)
			{
				removeChild(line);
				line = null;
				floodFill();
			}
		}
		
		
		private function floodFill():void
		{
			lineCopy= new Sprite();
			color = buildColor();
			index = 0;

			addEventListener(Event.ENTER_FRAME,floodit);
		}
			
			
		private function floodit(e:Event):void
		{
			lineCopy.graphics.clear();
			lineCopy.graphics.lineStyle(4, color, 0.1);
					
			var x:uint = lineStack[0][0];
			var y:uint = lineStack[0][1];
			
			var viewPoint = 3;
			
			lineCopy.graphics.moveTo(x, y);
			
			for(var i:uint=1;i<lineStack.length;i++)
			{
				//var modi:int = Math.cos((i * (180/lineStack.length)-90) * Math.PI / 180) * 10;
				var radius:uint = Math.abs(lineStack[i][0] - lineStack[0][0]);
				
				y = lineStack[i][1] + Math.cos(index * Math.PI / 180) * (radius / viewPoint);
				x = lineStack[0][0] + Math.sin(index * Math.PI / 180) * (radius);
				
				lineCopy.graphics.lineTo(x, y);
			}
			
			//matrix.scale(0.9999, 1.005);
			sketch.draw(lineCopy);
			index++;
		}
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():uint
		{
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 16 | G << 8 | B;
			
			//return nbr;
			
			// Ou alors : 
			return Math.random()*0xFFFFFF;
		}
	}
	
}